// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __PSFILTER_H
#define __PSFILTER_H

#include "source.h"
#include "transform.h"

/** Class to convert TS (actually PES) to PS streams **/

class PSFilter : public Source, public Sink {
public:

  PSFilter(Source *source);
  virtual ~PSFilter();

  virtual void receiveData(unsigned char *data, unsigned size);
  virtual bool subscribe(Sink *s);
  virtual void unsubscribe(Sink *s);
  virtual void notifyUnsubscribe(Source *s);

private:
  ipack packer;
  // Called when enough data is ready to write
  static void output(uint8_t *data, int size, void *priv);
  Source *source;
};

#endif // __PSFILTER_H
