// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __RECORDCONNECTION_H
#define __RECORDCONNECTION_H

#include "connection.h"
#include "recording.h"

class RecordConnection : public Connection {
public:

  RecordConnection(const Recording &rec, TunerManager *tm, int dataFD);

  virtual std::ostream& printOn(std::ostream &) const;

  virtual void addSelectFDs(Select &s) const;
  virtual bool processReady(const Select &s);

  bool tune();

  time_t getStopTime() const
  {
    return rec.getStopTime();
  }

  int getJob() const {
    return rec.getJob();
  }

protected:
  virtual std::string getType() const;

private:

  Recording rec; /** All the details of the recording */

};

#endif // __RECORDCONNECTION_H
